<?
/*************************************************************************************************/
/* Konfiguration                                                                                 */
/*************************************************************************************************/

// FritzBox / Adresse:
//*******************
// Tragen Sie hier den Hostnamen (z.B. Fritz.Box) oder die IP-Adresse (z.B. 192.168.1.1) der
// Fritzbox ein, bei globaler Konfiguration mit // auskommentieren.
//define ('FB_HOST',"fritz.box");

// FritzBox / Password:
//*******************
// Zum auslesen der Anruferliste ein Fritzbox-Benutzer benötigt.
// Dies sind u.A. die FTP/VPN etc... User in der Box.
// Bei globaler Konfiguration mit // auskommentieren.
//define ('FB_USER',"user@user.com");
//define ('FB_PASS',"password");

// FritzBox / Globale Konfig:
//*******************
// Globale Konfiguration der Zugangsdaten und Fritz-Box Adresse.
// Alternativ kann auch z.B. mit include eine PHP-Datei geladen werden wo diese Daten enthalten sind,
// dann braucht bei Änderungen nur eine Datei geändert werden.
require_once("45909.ips.php"); //Script welches folgendes Inhalt hat:
/*
define ('FB_HOST',"fritz.box");
define ('FB_USER',"user@user.com");
define ('FB_PASS',"password");
*/

//******************************************************************************
//Refresh des Anrufliste in Sekunden (0=deaktiviert)
//*******************
$refresh = 300; //Das Script kann z.B. auch durch den 'Gesprächsstatus' gestartet werden! Details im Wiki
// Außerdem wird das Script einmal um Mitternacht gestartet, damit 'Gestern' und 'Heute' auch am frühen Morgen stimmen :)
// PHP-Datei im WebFront-Verzeichniss welches die Audio-Datei bereitstellt.
$AB_URL = "user/fritz/ab.php";

//******************************************************************************
// Anzahl der Listen
//*******************
// Konfiguration der einzelnen Anruflisten (= Ident der Content Var und Name beim erstellen):
define ('FAMILY','FAMILY');
define ('TOCHTER','TOCHTER');
define ('DUMMY','DUMMY');

//******************************************************************************
// Filter / Nummern & Geräte
//*******************
// Welche Gespräche von/zu welcher eigenen Rufnummer sollen angezeigt werden ?
// leeres Array für alle (kein Filter)
$Liste[FAMILY]['Nummern'] = array("1234567","1234568");
$Liste[TOCHTER]['Nummern'] = array("987654");
$Liste[DUMMY]['Nummern'] = array();
// Welchen Port hat das FAX für die Liste ? (5 = standart der internen Faxfunktion, 0 = aus);
//********* NOCH NICHT UMGESETZT
$Liste[FAMILY]['FAX'] = 5;
$Liste[TOCHTER]['FAX'] = 5;
$Liste[DUMMY]['FAX'] = 5;
// Welche Anrufbeantworter-Ports sollen in welcher Liste stehen ?
// Sonst wird der Eintrag angezeigt, aber es stehen keine Steuerungselemente zur Verfügung (also nur sehen ohne abhören)
// 40 = 1.AB ...... 44 = 5.AB
//********* NOCH NICHT UMGESETZT
$Liste[FAMILY]['AB'] = array(40);
$Liste[TOCHTER]['AB'] = array(41);
$Liste[DUMMY]['AB'] = array(40);
// Filter / Gesprächstypen
// Welche Gesprächstypen (ankommen, abgehen, verpaßt) sollen in der Liste angezeigt werden ?
// leeres Array für alle (kein Filter)
/*
1 incoming,
2 missed,
3 outgoing,
4 AB new,
5 AB old,
9 active incoming,
10 rejected incoming,
11 active outgoing
*/
$Liste[FAMILY]['Type'] = array(1,2,3,4,5,9,10,11);
$Liste[TOCHTER]['Type'] = array(1,2,3,4,5,9,10,11);
$Liste[DUMMY]['Type'] = array(1,2,3,4,5,9,10,11);

// Liste / Filter Nebenstellen:
//*******************
// Mit diesem Parameter legen Sie fest, welche Nebenstellen nicht in der Anzeige dargestellt werden
// sollen (sie werden durch die eigene Rufnummer ersetzt). Dies ist z.B. dann sinnvoll, wenn hinter
// der Fritzbox eine ISDN-Anlage sitzt und diese in der Fritzbox als solche ohne spezielle MSN
// eingetragen ist. Dadurch erscheint in der Fritzbox-Anruferliste unter Nebenstelle immer nur der
// Name, mit dem die Telefonanlage eingetragen ist. Und durch Eintragen dieses Namens in den Konfi-
// gurationsparameter wird dieser nichtssagende Eintrag die die angerufene MSN ersetzt:
$Liste[FAMILY]['IgnoreDevice']=array();
$Liste[TOCHTER]['IgnoreDevice']=array();
$Liste[DUMMY]['IgnoreDevice']=array();

// Liste / Anzahl:
//*******************
// Je nach Platzverhältniss im WebFront passen mehr oder weniger Zeilen in die Anzeige. Sind mehr
// Zeilen in der Tabelle als Platz im Anzeigebereich vorhanden ist, wird automatisch ein Scroll-
// balken eingeblendet. Um das zu vermeiden kann die Anzahl der anzuzeigenden Verbindungen limi-
// tiert werden. Tragen Sie hier einen Wert zwischen 1 und 400 ein (die Fritzbox liefert maximal
// 400 Einträge zurück):
$Liste[FAMILY]['Anzahl'] = 30;
$Liste[TOCHTER]['Anzahl'] = 30;
$Liste[DUMMY]['Anzahl'] = 30;
// Liste / Limit Namen:
//*******************
// Sind die Einträge im Feld Namen zu lang für ihre Anzeige, so können Sie diese kürzen lassen.
// Die Funktion schneidet an der letzten möglichen Wortgrenze. Sie können hier Werte zwischen
// 0 und n eintragen, wobei 0 für NICHT kürzen steht, jeder andere Wert für kürzen auf n Zeichen:
$Liste[FAMILY]['LimitName'] = 30;
$Liste[TOCHTER]['LimitName'] = 30;
$Liste[DUMMY]['LimitName'] = 30;

// Liste / Datumsdarstellung:
//*******************
// Anzeige / Datum Maskieren:
// Diese Option aktivert eine Ersetzung das Datums, wenn der Eintrag von Heute oder Gestern ist.
// Somit sind die aktuellen Einträge leicher von älteren Einträgen zu unterscheiden.
// Folgende Optionen stehen zur verfügung:
// True                 Einträge mit aktuellem Datum durch "Heute", mit Datum von gestern durch
//                      "Gestern" ersetzen. Die Uhrzeitanzeige bleibt davon unberühert.
$Liste[FAMILY]['DatumMaskieren'] = true;
$Liste[TOCHTER]['DatumMaskieren'] = true;
$Liste[DUMMY]['DatumMaskieren'] = true;

// Liste / Spalten:
//*******************
// Anzeige / Felder:
// Zur Anzeige im Webfront wird eine HTML-Tabelle erzeugt. Mit dieser Einstellung legen Sie fest,
// welche Felder in welcher Reihenfolge in der Tabelle angezeigt werden sollen. Die folgenden
// Felder stehen ihnen dafür zur Verfügung:
// Icon: Typ               Anzeige des Verbindungstyps. Je nach Typ wird ein entsprechendes Symbol
//                        angezeigt (1 = CALLIN, 2 = CALLFAIL, 3 = CALLOUT, siehe Anzeige/Symbole)
// Date: Datum             Datum und Uhrzeit des Anruft
// Name: Name              Name des Anrufers
// Caller: Rufnummer         Rufnummer des Anrufers
// Device: Nebenstelle       Die eigene Nebenstelle. Ist dieses Feld leer oder trifft eine der Werte
//                        aus $keineNebenstelle zu, so wird das Feld "Eigene Rufnummer" verwendet
// Called: Eigene Rufnummer  Hier erscheint die Multiple Subscriber Number (MSN), welche der Anrufer
//                        erreichen wollte.
// Duration: Dauer             Hier wird die Dauer des Gesprächs ausgegeben. Die Dauer wird minutengenau
//                        erfasst und als Stunden:Minuten darstestellt.
// AB : Anrufbeantworter   Steuerung der Wiedergabe, sowie Button zum löschen.
// Tragen Sie in den Parameter die Indexnamen der Felder in der gewünschten Reihenfolge ein, die
// in der Ergebnistabelle erscheinen sollen:

$Liste[FAMILY]['Spalten'] = array("Icon","Date","Name","Caller","Device","Called","Duration","AB");
$Liste[TOCHTER]['Spalten'] = array("Icon","Date","Name","Caller","Device","Called","Duration","AB");
$Liste[DUMMY]['Spalten'] = array("Icon","Date","Name","Caller","Device","Called","Duration","AB");

// Anzeige / Spaltenbreite
// Mit dieser Option legen Sie die Spaltenbreite der anzuzeigenden Spalten fest. Die Option definiert
// für jede Spalte die Breite individuell, adressiert über den Feldindex gemäß Option Anzeige/Felder.
$Liste[FAMILY]['Breite'] = array(
    'Icon' => '50em',
    'Date' => '300em',
    'Name' => '400em',
    'Caller' => '200em',
    'Device' => '200em',
    'Called' => '200em',
    'Duration' => '75em',
    'AB' => '125em'
);

$Liste[TOCHTER]['Breite'] = array(
    'Icon' => '50em',
    'Date' => '300em',
    'Name' => '400em',
    'Caller' => '200em',
    'Device' => '200em',
    'Called' => '200em',
    'Duration' => '75em',
    'AB' => '125em'
);

$Liste[DUMMY]['Breite'] = array(
    'Icon' => '50em',
    'Date' => '300em',
    'Name' => '400em',
    'Caller' => '200em',
    'Device' => '200em',
    'Called' => '200em',
    'Duration' => '75em',
    'AB' => '125em'
);
// Anzeige / Tabellenstyle
// Mit dieser Option können CSS-Styleangaben für die verschiedenen Tabellenelemente machen.
// Die Tabelle hat folgenden Aufbau, die Feldkennzeichner stehen in {}-Klammern:
//    <table style="{T}">
//     <thead style="{H}">
//            <tr style="{HR}"><th style="{HFn}">text</th><th style="{HFn}">text</th>...<th style="{HFn}">text</th></tr>
//     </thead>
//     <tbody style="{B}">
//         <tr style="{BRG}"><td style="{DFGn}">daten</td><td style="{DFGn}">daten</td>...<td style="{DFGn}">daten</td></tr>
//         <tr style="{BRU}"><td style="{DFUn}">daten</td><td style="{DFUn}">daten</td>...<td style="{DFUn}">daten</td></tr>
//       ...
//    </tbody>
// </table>
// Die gewünschten Styleangaben werden als String im Array hinterlegt, jeweils mit dem
// entsprechenden Feldkennzeichner. Das (n) im Feldkennzeichner steht für den Feldindex, wie er im
// Parameter Anzeige/Felder festgelegt ist, d.h. sie legen im Style-Array für jedes Feld ein Style fest,
// unabhängig davon, wo Sie das entsprechende Feld letztlich anzeigen lassen.

$Liste[FAMILY]['Style'] = array(
    // <table>-Tag:
    'T'    => 'margin:0 auto; font-size:0.8em;',
    // <thead>-Tag:
    'H'    => '',
    // <tr>-Tag im thead-Bereich:
    'HR'   => '',
    // <th>-Tag Feld Typ:
    'HFIcon'  => 'width:35px; align:left;',
    // <th>-Tag Feld Datum:
    'HFDate'  => 'width:35px; align:left;',
    // <th>-Tag Feld Name:
    'HFName'  => 'width:35px; align:left;',
    // <th>-Tag Feld Rufnummer:
    'HFCaller'  => 'width:35px; align:left;',
    // <th>-Tag Feld Nebenstelle:
    'HFDevice'  => 'width:35px; align:left;',
    // <th>-Tag Feld Eigene Rufnummer:
    'HFCalled'  => 'width:35px; align:left;',
    // <th>-Tag Feld Dauer:
    'HFDuration'  => 'width:35px; align:left;',
    // <th>-Tag Feld AB:
    'HFAB'  => 'width:35px; align:left;',
    // <tbody>-Tag:
    'B'    => '',
    // <tr>-Tag:
    'BRG'  => 'background-color:#000000; color:ffff00;',
    'BRU'  => 'background-color:#080808; color:ffff00;',
    // <td>-Tag Feld Typ:
    'DFGIcon' => 'text-align:center;',
    'DFUIcon' => 'text-align:center;',
    // <td>-Tag Feld Datum:
    'DFGDate' => 'text-align:center;',
    'DFUDate' => 'text-align:center;',
    // <td>-Tag Feld Name:
    'DFGName' => '',
    'DFUName' => '',
    // <td>-Tag Feld Rufnummer:
    'DFGCaller' => 'text-align:center;',
    'DFUCaller' => 'text-align:center;',
    // <td>-Tag Feld Nebenstelle:
    'DFGDevice' => 'text-align:center;',
    'DFUDevice' => 'text-align:center;',
    // <td>-Tag Feld Eigene Rufnummer:
    'DFGCalled' => 'text-align:center;',
    'DFUCalled' => 'text-align:center;',
    // <td>-Tag Feld Dauer:
    'DFGDuration' => 'text-align:center;',
    'DFUDuration' => 'text-align:center;',
    // <td>-Tag Feld AB:
    'DFGAB' => 'text-align:center;',
    'DFUAB' => 'text-align:center;'
    // ^- Der Buchstabe "G" steht für gerade, "U" für ungerade.
 );

$Liste[TOCHTER]['Style'] = array(
     // <table>-Tag:
    'T'    => 'margin:0 auto; font-size:0.8em;',
    // <thead>-Tag:
    'H'    => '',
    // <tr>-Tag im thead-Bereich:
    'HR'   => '',
    // <th>-Tag Feld Typ:
    'HFIcon'  => 'width:35px; align:left;',
    // <th>-Tag Feld Datum:
    'HFDate'  => 'width:35px; align:left;',
    // <th>-Tag Feld Name:
    'HFName'  => 'width:35px; align:left;',
    // <th>-Tag Feld Rufnummer:
    'HFCaller'  => 'width:35px; align:left;',
    // <th>-Tag Feld Nebenstelle:
    'HFDevice'  => 'width:35px; align:left;',
    // <th>-Tag Feld Eigene Rufnummer:
    'HFCalled'  => 'width:35px; align:left;',
    // <th>-Tag Feld Dauer:
    'HFDuration'  => 'width:35px; align:left;',
    // <th>-Tag Feld AB:
    'HFAB'  => 'width:35px; align:left;',
    // <tbody>-Tag:
    'B'    => '',
    // <tr>-Tag:
    'BRG'  => 'background-color:#000000; color:ffff00;',
    'BRU'  => 'background-color:#080808; color:ffff00;',
    // <td>-Tag Feld Typ:
    'DFGIcon' => 'text-align:center;',
    'DFUIcon' => 'text-align:center;',
    // <td>-Tag Feld Datum:
    'DFGDate' => 'text-align:center;',
    'DFUDate' => 'text-align:center;',
    // <td>-Tag Feld Name:
    'DFGName' => '',
    'DFUName' => '',
    // <td>-Tag Feld Rufnummer:
    'DFGCaller' => 'text-align:center;',
    'DFUCaller' => 'text-align:center;',
    // <td>-Tag Feld Nebenstelle:
    'DFGDevice' => 'text-align:center;',
    'DFUDevice' => 'text-align:center;',
    // <td>-Tag Feld Eigene Rufnummer:
    'DFGCalled' => 'text-align:center;',
    'DFUCalled' => 'text-align:center;',
    // <td>-Tag Feld Dauer:
    'DFGDuration' => 'text-align:center;',
    'DFUDuration' => 'text-align:center;',
    // <td>-Tag Feld AB:
    'DFGAB' => 'text-align:center;',
    'DFUAB' => 'text-align:center;'
    // ^- Der Buchstabe "G" steht für gerade, "U" für ungerade.
 );
$Liste[DUMMY]['Style'] = array(
       // <table>-Tag:
    'T'    => 'margin:0 auto; font-size:0.8em;',
    // <thead>-Tag:
    'H'    => '',
    // <tr>-Tag im thead-Bereich:
    'HR'   => '',
    // <th>-Tag Feld Typ:
    'HFIcon'  => 'width:35px; align:left;',
    // <th>-Tag Feld Datum:
    'HFDate'  => 'width:35px; align:left;',
    // <th>-Tag Feld Name:
    'HFName'  => 'width:35px; align:left;',
    // <th>-Tag Feld Rufnummer:
    'HFCaller'  => 'width:35px; align:left;',
    // <th>-Tag Feld Nebenstelle:
    'HFDevice'  => 'width:35px; align:left;',
    // <th>-Tag Feld Eigene Rufnummer:
    'HFCalled'  => 'width:35px; align:left;',
    // <th>-Tag Feld Dauer:
    'HFDuration'  => 'width:35px; align:left;',
    // <th>-Tag Feld AB:
    'HFAB'  => 'width:35px; align:left;',
    // <tbody>-Tag:
    'B'    => '',
    // <tr>-Tag:
    'BRG'  => 'background-color:#000000; color:ffff00;',
    'BRU'  => 'background-color:#080808; color:ffff00;',
    // <td>-Tag Feld Typ:
    'DFGIcon' => 'text-align:center;',
    'DFUIcon' => 'text-align:center;',
    // <td>-Tag Feld Datum:
    'DFGDate' => 'text-align:center;',
    'DFUDate' => 'text-align:center;',
    // <td>-Tag Feld Name:
    'DFGName' => '',
    'DFUName' => '',
    // <td>-Tag Feld Rufnummer:
    'DFGCaller' => 'text-align:center;',
    'DFUCaller' => 'text-align:center;',
    // <td>-Tag Feld Nebenstelle:
    'DFGDevice' => 'text-align:center;',
    'DFUDevice' => 'text-align:center;',
    // <td>-Tag Feld Eigene Rufnummer:
    'DFGCalled' => 'text-align:center;',
    'DFUCalled' => 'text-align:center;',
    // <td>-Tag Feld Dauer:
    'DFGDuration' => 'text-align:center;',
    'DFUDuration' => 'text-align:center;',
    // <td>-Tag Feld AB:
    'DFGAB' => 'text-align:center;',
    'DFUAB' => 'text-align:center;'
    // ^- Der Buchstabe "G" steht für gerade, "U" für ungerade.
 );

//******************************************************************************
// Invers-Suche / Anbieter
//*******************
$Liste[FAMILY]['SucheType'] = 1;
$Liste[TOCHTER]['SucheType'] = 2;
$Liste[DUMMY]['SucheType'] = 2;

// Invers-Suche / CacheExpireTime
//*******************
// Zur Beschleunigung der Listenerstellung und zur Entlastung der Suchseiten ist in die Such-
// funktionen ein Caching der Ergebnisse eingebaut. Für jeden erfolgreich ermittelten Eintrag
// wird eine Datensatz in diesem Suchcache angelegt, der zukünftig sofort das Ergebnis liefert.
// Damit dieser Cache nicht unendlich groß wird, hat jeder Datensatz eine Ablaufzeit. Danach
// wird er aus dem Cache wieder entfernt.
// Dieser Parameter steuert, wie lange gefundene Einträge zu Rufnummern im Cache verbleiben.
// Die Angabe erfolg in Sekunden, für 24 Stunden ist also 86400 (=24*60*60) einzutragen:
$suche_cacheExpireTime = 86400 /*[Hardware\Fritz.Box\WAN-Connection\x_storageSCPD.xml\GetUserInfo\XAVMDENetworkAccessReadOnly]*/;

// Invers-Suche / CacheVarID
//*******************
// Mit diesem Parameter kann der Cache für mehrere Skripte gemeinsam genutzt werden.
// Ist dieser Parameter ungleich 0 ist, so wird er als VariablenID aufgefasst und der Cache in
// der entsprechenden Variable gespeichert. Damit einhergehend wird eine Verriegellung gegen
// gleichzeitige Zugriffe auf den Cache aktiviert, die mehrere Instanzen des Skripts
// untereinander im Zugriff synchronisiert. Defaultmäßig ist diese Funktion deaktiviert (d.h.
// der Parameter ist auf 0 gesetzt:
$suche_cacheVarID = 0;

// Invers-Suche / Nummer Wenn Nicht Gefunden
//*******************
// Mit dieser Einstellung legen Sie fest, ob bei nicht erfolgreicher Suche die Telefonnummer
// im Namensfeld eingetragen oder ob ein vorgegebener, statischer Text dort erscheinen soll.
// true                 Es wird die Telefonnummer des Anrufers im Feld Name eingetragen,
//                      wenn die Inverssuche nicht erfolgreich war.
// false                Es wird der stat. Text Invers-Suche / Unbekannt eingetragen.
$Liste[FAMILY]['NrBeiUnbekannt'] = false;
$Liste[TOCHTER]['NrBeiUnbekannt'] = false;
$Liste[DUMMY]['NrBeiUnbekannt'] = false;

// Invers-Suche / Unbekannt
//*******************
// Mit dieser Einstellung legen Sie den Text fest, der angezeigt werden soll, wenn eine
// durchgeführte Inverssuche kein Ergebnis geliefert hat. Siehe auch Einstellung des
// Parametes Invers-Suche / Nummer Wenn Nicht Gefunden
$Liste[FAMILY]['Unbekannt'] = "Unbekannt";
$Liste[TOCHTER]['Unbekannt'] = "Unbekannt";
$Liste[DUMMY]['Unbekannt'] = "Unbekannt";

// Invers-Suche / Treffer Markieren:
//*******************
// Mit diesem Parameter legen Sie fest, ob per Invers-Suche gefundene Einträge markiert werden
// sollen oder nicht. Die folgenden Optionen stehen zur verfügung:
// 0                    Keine Markierung
// 1                    Markierung per Klammerstern "(*)" am ANFANG des Eintrags.
// 2                    Markierung per Klammerstern "(*)" am ENDE des Eintrags.
// 3                    Markierung per Symbol am ANFANG des Eintrags (Symbol = SEARCHHIT)
// 4                    Markierung per Symbol am ENDE des Eintrags (Symbol = SEARCHHIT)
$Liste[FAMILY]['SucheMarker'] = 1;
$Liste[TOCHTER]['SucheMarker'] = 1;
$Liste[DUMMY]['SucheMarker'] = 1;

// Anzeige / Symbole:
//*********************
// Bei der Anzeige im WebFront kommen 4 verschiedene Symbole zum Einsatz. Mit diesem Parameter
// legen Sie fest, welches Symbol für welchen Zweck verwendung finden soll. Sie können alle
// Bilddateien angeben die der Browser anzeigen kann. Achten Sie darauf, das die Symbole eine
// angemessene Größe haben, da der Browser die Symbole mit Originalabmessung anzeigt.
// Die Symbole und ihre Bedeutung sind:
// CALLIN               Dieses Symbol wird in der Spalte Typ angezeigt, wenn ein eingehender Anruf
//                        angenommen wurde (d.h. ein Gespräch ist zustande gekommen)
// CALLFAIL             Dieses Symbol wird in der Spalte Typ angezeigt, wenn ein eingehender oder
//                        ausgehender Anruf NICHT angenommen wurde (d.h. es hat geklingelt und
//                        NIEMAND hat abgehoben)
// CALLOUT              Dieses Symbol wird in der SPalte Typ angezeigt für alle Verbindungen, die
//                        ausgehend sind (d.h. es wurde jemand angerufen und der jenige hat
//                        abgehoben)
//
//
// Doku fehlt noch
//
//
//
$Liste[FAMILY]['Symbole']['Icon'] = array(
    'CALLIN'    => 'user/fritz/Callin.png',
    'CALLFAIL'  => 'user/fritz/Callinfailed.png',
    'CALLOUT'   => 'user/fritz/Callout.png',
    'CALLNEW'   => 'user/fritz/Msgnew.png',
    'CALLOLD'   => 'user/fritz/Msgold.png',
    'SEARCHHIT' => 'user/fritz/suche.png',
    'AB_START'  => 'user/fritz/start.png',
    'AB_STOP'   => 'user/fritz/pause.png',
    'AB_BEGIN'  => 'user/fritz/begin.png',
    'AB_DELETE' => 'user/fritz/loeschen.png'
);
// Anzeige / Symbolgrösse
//*********************
// Dieser Parameter legt die Anzeigegröße für alle Symbole einheitlich fest. Geben Sie einen
// beliebigen Pixel-Wert an, welcher für die Attribute Width und Height eingetragen wird:
$Liste[FAMILY]['Symbole']['Size'] = 26;

// Anzeige / Symbolstyle
//*********************
// Mit diesem Parameter können Sie für jedes der Symbole weitere CSS-Styles festlegen, die in
// die Tabelle übernommen werden sollen. Sie können je Symboltyp (siehe Anzeige/Symbole)
// individuelle Angaben machen.
$Liste[FAMILY]['Symbole']['Style'] = array(
    'CALLIN'    => 'margin:1px 0 0;',
    'CALLFAIL'  => 'margin:1px 0 0;',
    'CALLOUT'   => 'margin:1px 0 0;',
    'CALLNEW'   => 'margin:1px 0 0;',
    'CALLOLD'   => 'margin:1px 0 0;',
    'SEARCHHIT' => 'margin:1px 0 0;',
    'AB_START'  => 'margin:1px 0 0; cursor: pointer;',
    'AB_STOP'   => 'margin:1px 0 0; cursor: pointer;',
    'AB_BEGIN'  => 'margin:1px 0 0; cursor: pointer;',
    'AB_DELETE' => 'margin:1px 0 0; cursor: pointer;',
);

$Liste[TOCHTER]['Symbole']['Icon'] = array(
    'CALLIN'    => 'user/fritz/Callin.png',
    'CALLFAIL'  => 'user/fritz/Callinfailed.png',
    'CALLOUT'   => 'user/fritz/Callout.png',
    'CALLNEW'   => 'user/fritz/Msgnew.png',
    'CALLOLD'   => 'user/fritz/Msgold.png',
    'SEARCHHIT' => 'user/fritz/suche.png',
    'AB_START'  => 'user/fritz/start.png',
    'AB_STOP'   => 'user/fritz/pause.png',
    'AB_BEGIN'  => 'user/fritz/begin.png',
    'AB_DELETE' => 'user/fritz/loeschen.png'
);
$Liste[TOCHTER]['Symbole']['Size'] = 26;
$Liste[TOCHTER]['Symbole']['Style'] = array(
    'CALLIN'    => 'margin:1px 0 0;',
    'CALLFAIL'  => 'margin:1px 0 0;',
    'CALLOUT'   => 'margin:1px 0 0;',
    'CALLNEW'   => 'margin:1px 0 0;',
    'CALLOLD'   => 'margin:1px 0 0;',
    'SEARCHHIT' => 'margin:1px 0 0;',
    'AB_START'  => 'margin:1px 0 0; cursor: pointer;',
    'AB_STOP'   => 'margin:1px 0 0; cursor: pointer;',
    'AB_BEGIN'  => 'margin:1px 0 0; cursor: pointer;',
    'AB_DELETE' => 'margin:1px 0 0; cursor: pointer;',
);

$Liste[DUMMY]['Symbole']['Icon'] = array(
    'CALLIN'    => 'user/fritz/Callin.png',
    'CALLFAIL'  => 'user/fritz/Callinfailed.png',
    'CALLOUT'   => 'user/fritz/Callout.png',
    'CALLNEW'   => 'user/fritz/Msgnew.png',
    'CALLOLD'   => 'user/fritz/Msgold.png',
    'SEARCHHIT' => 'user/fritz/suche.png',
    'AB_START'  => 'user/fritz/start.png',
    'AB_STOP'   => 'user/fritz/pause.png',
    'AB_BEGIN'  => 'user/fritz/begin.png',
    'AB_DELETE' => 'user/fritz/loeschen.png'
);
$Liste[DUMMY]['Symbole']['Size'] = 26;
$Liste[DUMMY]['Symbole']['Style'] = array(
    'CALLIN'    => 'margin:1px 0 0;',
    'CALLFAIL'  => 'margin:1px 0 0;',
    'CALLOUT'   => 'margin:1px 0 0;',
    'CALLNEW'   => 'margin:1px 0 0;',
    'CALLOLD'   => 'margin:1px 0 0;',
    'SEARCHHIT' => 'margin:1px 0 0;',
    'AB_START'  => 'margin:1px 0 0; cursor: pointer;',
    'AB_STOP'   => 'margin:1px 0 0; cursor: pointer;',
    'AB_BEGIN'  => 'margin:1px 0 0; cursor: pointer;',
    'AB_DELETE' => 'margin:1px 0 0; cursor: pointer;',
);

// Sonstiges / LogMode:
//*********************
// Mit dieser Option stellt am ein, aus welche Art und Weise Logging-Meldungen vom Skript
// erzeugt werden. Es werden derzeit 2 Varianten unterstützt:
// 0                    Keine Logmeldungen erzeugen
// 1                    Logmeldungen via IPS_LogMessage (default)
// 2                    Logmeldungen via IPSLogger (ACHTUNG: IPS-Library mit IPSLogger muss
//                      installiert sein um diese Funktion nutzen zu können).
$LogMode = 1;

/*************************************************************************************************/
/* Ab hier nichts mehr ändern                                                                    */
/*************************************************************************************************/
if ($LogMode == 2) {
    IPSUtils_Include ("IPSLogger.inc.php", "IPSLibrary::app::core::IPSLogger");
}
// Loglevel für Meldungen
define('FATAL', 0, true);
define('ERROR', 1, true);
define('WARNING', 2, true);
define('NOTIFICATION', 3, true);
define('INFORMATION', 4, true);
define('DEBUG', 5, true);
define('COMMUNICATION', 6, true);
define('TRACE', 7, true);
define('TEST', 8, true);

$icons = array(  //Type zu Index der Styles in der Config
1=>'CALLIN',
2=>'CALLFAIL',
3=>'CALLOUT',
4=>'CALLNEW',  //eigens für den AB
5=>'CALLOLD', //eigens für den AB
9=>'CALLOUT',
10=>'CALLFAIL',
11=>'CALLOUT'
);

$object = IPS_GetObject($_IPS['SELF']);
$parentID = $object['ParentID'];

//Installer
if ($_IPS['SENDER'] == 'Execute')
{
	IPS_SetHidden($_IPS['SELF'], true);
	IPS_SetName($_IPS['SELF'], 'Auslese-Skript');
	$parentObject = IPS_GetObject($parentID);
	if ($parentObject['ObjectType'] !== 1)
	{
		$instanceID = IPS_CreateInstance('{485D0419-BE97-4548-AA9C-C083EB82E61E}');
      IPS_SetParent($instanceID, $parentID);
      $parentID = $instanceID;
      IPS_SetParent($_IPS['SELF'], $parentID);
      IPS_SetName($instanceID, 'Anruferlisten');
	}
	IPS_SetScriptTimer($_IPS['SELF'], $refresh);
	$timer = @IPS_GetObjectIDByIdent("MidnightTimer",$_IPS['SELF']);
	if ($timer === false)
	{
		$timer =	IPS_CreateEvent(1);
		IPS_SetIdent($timer,"MidnightTimer");
		IPS_SetName($timer,"MidnightTimer");
      IPS_SetParent($timer,$_IPS['SELF']);
	}
	IPS_SetEventCyclic($timer,2,1,0,0,0,0);
	IPS_SetEventActive($timer,true);
}

// Daten holen und Kombinieren
$ABMessageListe =FB_GetABMessageList();
if ($ABMessageListe === false) return;  //Fehlermeldung in Funktion schon erzeugt

$Anrufliste = FB_GetCallList();
if ($Anrufliste === false) return;  //Fehlermeldung in Funktion schon erzeugt

//foreach ($Anrufliste->Call as $Key=>$Anruf) // geht nicht da $Key nicht der Index ist :(
// Liste vorbereiten -> Nummern tauschen ändern, bereinigen und AB-Einträge ergänzen
for ($i=0;$i<count($Anrufliste->Call);$i++)
{
	// Nur bei Abgehend die Nummern tauschen, dann muss das nachher nicht gemacht werden.
	if ((int)$Anrufliste->Call[$i]->Type == 3)
	{
		$tmp = (string)$Anrufliste->Call[$i]->Caller;
		$Anrufliste->Call[$i]->Caller = (string)$Anrufliste->Call[$i]->Called;
		$Anrufliste->Call[$i]->Called = $tmp;
	}
	$Anrufliste->Call[$i]->Name = utf8_decode($Anrufliste->Call[$i]->Name);
	$Anrufliste->Call[$i]->Device = utf8_decode($Anrufliste->Call[$i]->Device);
	// Eigene Nummer bereinigen, entfernt z.B. ISDN: POTS: SIP: etc...
	$Anrufliste->Call[$i]->Called = str_replace(strtoupper((string)$Anrufliste->Call[$i]->Numbertype).": ","",(string)$Anrufliste->Call[$i]->Called);
	$Anrufliste->Call[$i]->addChild("AB"); // leeren AB Eintrag erzeugen.
	// Port der Rufannahme ein AB-Port ?
	if (((int)$Anrufliste->Call[$i]->Port >= 40) && ((int)$Anrufliste->Call[$i]->Port <= 44) && (strlen((string)$Anrufliste->Call[$i]->Path) <> 0))
	{
		// Gleiche Message vom AB holen
		$ABxml = $ABMessageListe[(int)$Anrufliste->Call[$i]->Port]->xpath("//Message[Path ='".(string)$Anrufliste->Call[$i]->Path."']");
		// Anrufliste erweitern
		$Anrufliste->Call[$i]->addChild("Tam"); // AB -Eintrag erzeugen
		$Anrufliste->Call[$i]->Tam->addAttribute("index",(string)$ABxml[0]->Tam); // Welcher AB ?
		$Anrufliste->Call[$i]->Tam->addChild("TamIndex",(string)$ABxml[0]->Index); // Welcher Index hat die Nachricht von diesem AB ?
		$Anrufliste->Call[$i]->Type= ((string)$ABxml[0]->New == "1" ? "4" : "5");  // Nachricht neu oder alt ?
		$Anrufliste->Call[$i]->AB = "1"; // AB-Eintrag ist vorhanden !
		$Anrufliste->Call[$i]->Path =  $AB_URL."?path=".urlencode((string)$Anrufliste->Call[$i]->Path);// URL-Anpassen
		$Anrufliste->Call[$i]->Duration = "---";  // Warum auch immer ist die Dauer immer 0:01 ???
	}
}

$searchFailed = array(); // Alle nicht gefunden Nummern hier rein.

foreach ($Liste as $Key => $Config)  // Alle Listen erzeugen.
{
	//Liste für diese Config vorbereiten
	// Xpath zusammenbauen
	$XPath = GetNumberXpath($Config['Nummern']);
	$XPath .= GetTypeXpath($Config['Type']);
	// Header
	$HTMLData=GetTableHeader($Config);
	// Liste erzeugen. Start festlegen
	$pos=0;
	// Daten filtern mit xPath und schleife erzeugen
	foreach ($Anrufliste->xpath("//Call".$XPath) as $Call)
	{
		// Eintrag für Eintrag Daten aufbereiten
		if (strlen((string)$Call->Name) == 0) // Namen suchen ?
		{
			if (($Config['SucheType'] == 0) || (in_array((string)$Call->Caller, $searchFailed))) // Suche abgeschaltet oder num wurde schon gesucht und nicht gefunden
			{
      	   $Call->Name = ($Config['NrBeiUnbekannt'] ? (string)$Call->Caller : $Config['Unbekannt']);
			} else {
				$result = InversSuche((string)$Call->Caller, $Config['SucheType']);
				if ($result == false)
				{
               $searchFailed[] =(string)$Call->Caller;
               $Call->Name = ($Config['NrBeiUnbekannt'] ? (string)$Call->Caller : $Config['Unbekannt']);
            } else {
           	   $result['Name'] = TextAbschneiden($result['Name'], $Config['LimitName']); // Text abschneiden
         		switch((int)$Config['SucheMarker'])
					{
            		case 0: $Call->Name = $result['Name']; break;
			         case 1: $Call->Name = '(*)'.$result['Name']; break;
   			      case 2: $Call->Name = $result['Name'].'(*)'; break;
			         case 3: $Call->Name = GetImage($Config['Symbole'],"SEARCHHIT").' '.$result['Name']; break;
			         case 4: $Call->Name = $result['Name'].' '.GetImage($Config['Symbole'],"SEARCHHIT"); break;
			      }
           	}
        	}
		} else { // Name vorhanden nur kürzen
		   $Call->Name = TextAbschneiden($Call->Name, $Config['LimitName']);
		}
		// Namen bearbeiten
	   if ((string)$Call->Port = "-1") $Call->Device=(string)$Call->Called; // Wenn nicht angenommen also Port = -1 dann Tel-Nummer als Gerätenamen
	   if (in_array((string)$Call->Device,$Config['IgnoreDevice'])) $Call->Device=(string)$Call->Called; // Wenn Device in ignorier-Liste dann Tel-Nummer als Gerätenamen
	   if (strlen((string)$Call->Caller) == 0) $Call->Caller = (string)$Call->Name; // Wenn Nummer leer ist, den Eintrag vom Namen aus der FB übernehmen (bei deutscher FritzBox = unbekannt)
		// Datum bearbeiten
    	if ($Config['DatumMaskieren'])
		 {
       	$parts   = preg_split('/[ .:]/', (string)$Call->Date);
			$datum   = mktime(0, 0, 1, (int)$parts[1], (int)$parts[0], (int)$parts[2]);
        	$heute   = mktime(0, 0, 0);
       	$gestern = $heute - 86400;
        	if ($datum > $heute) {
         	$parts[5] = 'Heute -  ';
        	} elseif ($datum > $gestern) {
         	$parts[5] = 'Gestern - ';
        	} else {
         	$parts[5] = date('d.m.y ', $datum);
        	}
        	$Call->Date = $parts[5].$parts[3].':'.$parts[4];
    	}
		// ICON festlegen
		$Call->addChild("Icon",GetImage($Config['Symbole'],$icons[(int)$Call->Type]));
		// AB Eintrag erzeugen ?
		if ((int)$Call->AB == 1) //&& (in_array((int)$Call->Port,$Config['AB'])))  // Port stimmt nicht immer ?!?!
		{
		   $Call->AB='<audio id="'.(string)$Call->Tam->TamIndex.'" preload="none">
                             <source src="'.(string)$Call->Path.'" type="audio/wav">
                             keine Unterstützung für Audioelemente
                          </audio>
                         <div>'
								 .GetImage($Config['Symbole'],'AB_START','onclick="document.getElementById('.(string)$Call->Tam->TamIndex.').play();" ')
								 .GetImage($Config['Symbole'],'AB_STOP','onclick="document.getElementById('.(string)$Call->Tam->TamIndex.').pause();" ')
								 .GetImage($Config['Symbole'],'AB_BEGIN','onclick="document.getElementById('.(string)$Call->Tam->TamIndex.').currentTime = 0;" ')
                         .'</div>';
		} else {
			$Call->AB = "";
		}
		$HTMLData .='<tr style="'.$Config['Style']['BR'.($pos % 2 ? 'U':'G')].'">';
      foreach($Config['Spalten'] as $feldIndex)
		{
			$HTMLData .= '<td style="'.$Config['Style']['DF'.($pos % 2 ? 'U':'G').$feldIndex].'">'.$Call->{$feldIndex}.'</td>';
		}
      $HTMLData .= '</tr>'.PHP_EOL;
		$pos++;
		if($pos >= $Config['Anzahl']) break;
	}
	$HTMLData .= GetTableFooter();
	$var_id = GetOrCreateVariableByIdent($parentID,$Key,3,$Key,"speaker","~HTMLBox");
	SetValueString($var_id, $HTMLData);

}

function FB_GetCallList()
{
	$client = new SoapClient(
   	 null,
	    array(
        'location'   => "http://".FB_HOST.":49000/upnp/control/x_contact",
        'uri'        => "urn:dslforum-org:service:X_AVM-DE_OnTel:1",
        'noroot'     => True,
        'login'      => FB_USER,
        'password'   => FB_PASS
   	 )
	);
	$URL = FB_NOSLL($client->GetCallList());
	$xml = @simplexml_load_file($URL);
	if ($xml === false)
	{
		WriteLogMessage(FATAL, 'Datei: '.__file__.' Zeile: '.__line__, 'Fehler beim laden der Anrufliste.');
		return false;
	}
	return $xml;
}

function FB_NOSLL ($URL)
{
	return str_replace(array("https://",":49443"),array("http://",":49000"),$URL); // bitte ohne SSL
}

function FB_GetABMessageList()
{
	$client = new SoapClient(
   	 null,
	    array(
        'location'   => "http://".FB_HOST.":49000/upnp/control/x_tam",
        'uri'        => "urn:dslforum-org:service:X_AVM-DE_TAM:1",
        'noroot'     => True,
        'login'      => FB_USER,
        'password'   => FB_PASS
   	 )
	);
	for ($i=0;$i<5;$i++)
	{
		$GetInfo = $client->GetInfo(new SoapParam($i,"NewIndex"));
		if ($GetInfo["NewName"] <> "")
		{
			$URL = FB_NOSLL($client->GetMessageList(new SoapParam($i,"NewIndex")));
			$xml = @simplexml_load_file($URL);
			if ($xml === false)
			{
				WriteLogMessage(FATAL, 'Datei: '.__file__.' Zeile: '.__line__, 'Fehler beim laden der AB_Nachrichten.');
				return false;
			}
			$AB_Data[40+$i]=$xml;
		}
	}
	return $AB_Data;
}

function GetImage($Config,$Symbol,$JavaScript = "")
{
	return '<img src="'.$Config['Icon'][$Symbol].'" width="'.$Config['Size'].'px" height="'.$Config['Size'].'px" style="'.$Config['Style'][$Symbol].'" '.$JavaScript.'/>';
}

function GetNumberXpath ($Nummern)
{
	if ( count($Nummern) == 0) return "";
	$XPath="[Called='".implode("' or Called='",$Nummern)."']";
	return $XPath;
}

function GetTypeXpath ($Type)
{
	if ( count($Type) == 0) return "";
	$XPath="[Type='".implode("' or Type='",$Type)."']";
	return $XPath;
}

function GetOrCreateVariableByIdent($parent,$ident,$type,$pos=0,$icon='',$profile='')
{
	if (!ctype_alnum($ident))
	{
		echo "ERROR: Konnte Variable nicht hinzufügen. Ident kann nicht verwendet werden:".$ident.PHP_EOL;
		return;
	}
	$var_id = @IPS_GetObjectIDByIdent($ident,$parent);
	if ($var_id === false)
	{
		$var_id = IPS_CreateVariable($type);
		IPS_SetName($var_id,$ident);
		IPS_SetIdent($var_id,$ident);
		IPS_SetParent($var_id,$parent);
		if ($pos <> 0)	IPS_SetPosition($var_id,$pos);
		IPS_SetIcon($var_id,$icon);
		IPS_SetVariableCustomProfile($var_id,$profile);
	}
	return $var_id;
}

function GetTableHeader ($Config)
{
	$felder = array('Icon'=>'Typ', 'Date'=>'Datum', 'Name'=>'Name', 'Caller'=>'Rufnummer', 'Device'=>'Nebenstelle', 'Called'=>'Eigene Rufnummer', 'Duration'=>'Dauer','AB'=>'Nachricht');
	// Kopf der Tabelle erzeugen
	$html  = "<table bgcolor='#000000'><body scroll=no><body bgcolor='#000000'><table style=".$Config['Style']['T'].'">'.PHP_EOL;
	$html .= '<colgroup>'.PHP_EOL;
	foreach($Config['Spalten'] as $Index)
	{
   	$html .= '<col width="'.$Config['Breite'][$Index].'" />'.PHP_EOL;
	}
	$html .= '</colgroup>'.PHP_EOL;
	$html .= '<thead style="'.$Config['Style']['H'].'">'.PHP_EOL;
	$html .= '<tr style="'.$Config['Style']['HR'].'">';
	foreach($Config['Spalten'] as $Index)
	{
   	$html .= '<th style="color:ffff00; '.$Config['Style']['HF'.$Index].'">'.$felder[$Index].'</th>';
	}
	$html .= '</tr>'.PHP_EOL;
	$html .= '</thead>'.PHP_EOL;
	$html .= '<tbody style="'.$Config['Style']['B'].'">'.PHP_EOL;
	return $html;
}

function GetTableFooter()
{
	$html = '</tbody>'.PHP_EOL;
	$html .= '</table>'.PHP_EOL;
	return $html;
}

// Erzeugt je nach Einstellung eine Meldung im IPS Logbuch oder via IPSLogger (sonstige/LogMode)
 function WriteLogMessage($level, $location, $information) {
    global $sonstige_LogMode;

    $logLevel = array(
        'Fatal:',            // LogLevel=0: Schwerwiegende Fehler, führt normalerweise zu einem kompletten
                                 //   Programmabbruch
        'Error:',            // LogLevel=1: 'Normale' Fehler
        'Warning:',            // LogLevel=2: Warnungen
        'Notification:',    // LogLevel=3: Notifizierung, wird benutzt um sich über bestimmte Ereignisse im
                                 //   System informieren zu lassen (Beschattung wurde aktiviert, oder Rasenbewässerung
                                 //   gestartet)
        'Information:',    // LogLevel=4: Informationsmeldungen, zur Protokollierung von Schaltvorgängen usw.
         'Debug:',            // LogLevel=5: Debug Meldungen
        'Communication:',    // LogLevel=6: Protokollierung von Kommunikations Instanzen (Senden/Empfangen über
                                 //   RS232, Sockets, ...)
        'Trace:',            // LogLevel=7: Sehr detailierte Meldungen, um diverse Ablauffehler zu finden
         'Test:'                // LogLevel=8: Test Meldungen, verwende ich nur temporär um Fehler zu finden, man kann
                                 //   nach diesen Meldungen suchen und sie nach finden des Fehlerers wieder entfernen
     );

    switch ($sonstige_LogMode) {
       case 1: // Logging via IPS_LogMessage
          IPS_LogMessage($location, $logLevel[$level].' '.$information);
      break;
        case 2: // Logging via IPSLogger
           switch ($level) {
              case 0: IPSLogger_Fat($location, $information); break;
              case 1: IPSLogger_Err($location, $information); break;
              case 2: IPSLogger_Wrn($location, $information); break;
              case 3: IPSLogger_Not($location, $information); break;
              case 4: IPSLogger_Inf($location, $information); break;
              case 5: IPSLogger_Dbg($location, $information); break;
              case 6: IPSLogger_Com($location, $information); break;
              case 7: IPSLogger_Trc($location, $information); break;
              case 8: IPSLogger_Tst($location, $information); break;
            }
        break;
    }
}

function QueryTelSearchCh($Rufnummer) {
    $record = false;
    $pageurl = "http://tel.search.ch/?tel=$Rufnummer";
    $wsdata = @Sys_GetURLContent($pageurl);
    if ($wsdata === false) {
       WriteLogMessage(WARNING, 'Datei: '.__file__.' Zeile: '.__line__, 'Timeout bei Abruf der Webseite '.$pageurl);
     } else {
        $data = str_replace(array(CRLF, LF), ' ', $wsdata);
        if (preg_match('/class="fn">(.*?)<\/a>.*class="adrgroup street-address">(.*) ([0-9]+[0-9a-zA-Z]*)'.
                        '<\/span>.*class="postal-code">(.*?)<\/span>.*class="locality">(.*?)<\/span>/', $data, $result)) {
             $record = array(
                'Name'              => html_entity_decode(trim($result[1]))/* ,
                'Strasse'           => html_entity_decode(trim($result[2])),
                'Hausnummer'        => html_entity_decode(trim($result[3])),
                'PLZ'               => html_entity_decode(trim($result[4])),
                'Ort'               => html_entity_decode(trim($result[5])),
                'StrasseHausnummer' => html_entity_decode(trim($result[2]).' '.trim($result[3])),
                 'PLZOrt'            => html_entity_decode(trim($result[4]).' '.trim($result[5]))*/
             );
        }
    }
    return $record;
}

function QueryDasOertlicheDe($Rufnummer)
{
   $record = false;
   $url = "http://www.dasoertliche.de/Controller?form_name=search_inv&ph=$Rufnummer";
	# Create a DOM parser object
	$dom = new DOMDocument();
	# Parse the HTML from klicktel
	# The @ before the method call suppresses any warnings that
	# loadHTMLFile might throw because of invalid HTML or URL.
	@$dom->loadHTMLFile($url);
	if ($dom->documentURI == null)
	{
   	WriteLogMessage(WARNING, 'Datei: '.__file__.' Zeile: '.__line__, 'Timeout bei Abruf der Webseite '.$url);
		return false; // DOH! nix geladen zurück
	}
	$finder = new DomXPath($dom);
	$classname="hit clearfix ";
	$nodes = $finder->query("//*[contains(concat(' ', normalize-space(@class), ' '), '$classname')]");
	if ($nodes->length == 0) return false;
	$cNode = $nodes->item(0); //div left
	if ($cNode->nodeName != 'div') return false;
	if (!$cNode->hasChildNodes()) return false;
	$ahref = $cNode->childNodes->item(1); // a href
	if (!$ahref->hasChildNodes()) return false;
	foreach ($ahref->childNodes as $div)
	{
	   if ($div->nodeName == "a" ) break;
	}
   $record = array(
   	'Name'              => trim(utf8_decode($div->nodeValue))
    );
    return $record;
}

function QueryKlickTelDe ($Rufnummer)
{
	$url = 'http://www.klicktel.de/rueckwaertssuche/' . $Rufnummer;
	# Create a DOM parser object
	$dom = new DOMDocument();
	# Parse the HTML from klicktel
	# The @ before the method call suppresses any warnings that
	# loadHTMLFile might throw because of invalid HTML or URL.
	@$dom->loadHTMLFile($url);
	if ($dom->documentURI == null)
	{
   	WriteLogMessage(WARNING, 'Datei: '.__file__.' Zeile: '.__line__, 'Timeout bei Abruf der Webseite '.$url);
		return false; // DOH! nix geladen zurück
	}
	$finder = new DomXPath($dom);
	$classname="results direct";
	$nodes = $finder->query("//*[contains(concat(' ', normalize-space(@class), ' '), ' $classname ')]");
	if ($nodes->length == 0) return false;
	$ulNode = $nodes->item(0); //ul
	if ($ulNode->nodeName != 'ul') return false; // doch kein ul
	if ($ulNode->childNodes->length == 0) return false;
	$liNode = $ulNode->childNodes->item(0); //li
	if ($liNode->nodeName != 'li') return false; // doch kein li
	if ($liNode->childNodes->length < 1) return false; // kein Eintrag
	$divNode = $liNode->childNodes->item(1); //1.div
	if ($divNode->nodeName != 'div') return false; // kein div
	if ($divNode->childNodes->length < 2) return false; // anzahl stimmt nicht
	$h3Node = $divNode->childNodes->item(3); // h3
	if ($h3Node->tagName != 'h3') return false; // doch kein h3
   $record = array(
       'Name'              =>   trim(utf8_decode($h3Node->nodeValue))
   );
	return $record;
}

// Führt eine Cache-unterstützte Suche nach der Rufnummer durch
function InversSuche($Rufnummer, $modus)
{
	global $parentID, $suche_cacheExpireTime, $suche_cacheVarID;
   // Daten aus dem Suchcache laden
   $cacheData = GetCacheData();

   // Ergebnisrecord mit false vorbelegen
   $record = false;

   // Suchcache checken, ob ein Eintrag passend zur Rufnummer vorhanden ist
   if (isset($cacheData[$Rufnummer]))
	{  // Treffer im Cache, Daten holen und rück zum Aufrufer springen
		$record = $cacheData[$Rufnummer]['Data'];
	}
	// Wenn im Cache kein Treffer gefunden wurde, eine Websuchmaschine befragen
	if ($record === false)
	{
   	switch ($modus)
		{
			case 1: $record = QueryDasOertlicheDe($Rufnummer); break;
			case 2: $record = QueryKlickTelDe($Rufnummer); break;
			case 3: $record = QueryTelSearchCh($Rufnummer); break;
		}
		// Wenn wir jetzt einen Treffer haben, muss der noch in den Cache...
      if ($record !== false) AddRecordToCache($Rufnummer, $record);
	}
	// So, jetzt sind wird fertig, zurück zum Aufrufer...
	return $record;
}

// Liefert die aktuellen Daten aus dem Cache als Array an den Aufrufer
function GetCacheData()
{
	global $suche_cacheVarID, $parentID;
	$globalCache = false;
   // ID der Cachevariable ermitteln
   if ($suche_cacheVarID == 0) {
      // Wir arbeiten mit einem eigenen Cache
      $varID = GetOrCreateVariableByIdent($parentID, 'searchcache', 3);
   } else {
      $globalCache = true;
      $varID = $suche_cacheVarID;
   }
   // Wenn wir mit globalem Cache arbeiten müssen wir jetzt ein Lock holen
   if ($globalCache)
	{
       if (!IPS_SemaphoreEnter('FB_cache_lock', 2000)) return false;  // Und ende... beim nächsten mal mehr Glück...
   }
   // Die Cache-Daten aus der Variable holen und deserialisieren
   $data = GetValueString($varID);
   if ($globalCache) IPS_SemaphoreLeave('FB_cache_lock');        // Jetzt noch die Semaphore zurückgeben
   // und deserialisieren
   if (($result = @unserialize($data)) === FALSE)
	{
      $result = array();
   }
   // fertig, das Array mit den cache-daten an den Aufrufer zurückliefern
   return $result;
}

function AddRecordToCache($Rufnummer, $record)
{
   global $suche_cacheVarID, $suche_cacheExpireTime, $parentID;
   $globalCache = false;
   // ID der Cachevariable ermitteln
   if ($suche_cacheVarID == 0) {
       // Wir arbeiten mit einem eigenen Cache
       $varID = GetOrCreateVariableByIdent($parentID, 'searchcache', 3);
   } else {
       $globalCache = true;
       $varID = $suche_cacheVarID;
   }
   // Wenn wir mit globalem Cache arbeiten müssen wir jetzt ein Lock holen
   if ($globalCache)
	{
		if (!IPS_SemaphoreEnter('FB_cache_lock', 2000)) return false;  // Und ende... beim nächsten mal mehr Glück...
   }
   // Die Cache-Daten aus der Variable holen und deserialisieren
   $data = GetValueString($varID);
   if (($cache = @unserialize($data)) === FALSE) $cache = array();
    // Jetzt den neuen Eintrag in $data vornehmen
    $cache[$Rufnummer] = array('Expire' => (time() + $suche_cacheExpireTime), 'Data' => $record);
    // Das ganze wieder serialisieren und in die Variable zurückschreiben
    $data = serialize($cache);
    SetValueString($varID, $data);
    if ($globalCache) IPS_SemaphoreLeave('FB_cache_lock');        // Jetzt noch die Semaphore zurückgeben
    return true;
}

function TextAbschneiden($Text, $Laenge) {
   if ($Laenge == 0)
	{
      return $Text;
   } else {
      $GekuerzterText = substr($Text, 0, strpos(wordwrap($Text, $Laenge-1, '*!U-M-B-R-U-C-H*'),
           '*!U-M-B-R-U-C-H*'));
      if($GekuerzterText) {
          return $GekuerzterText;
      } else {
          return $Text;
      }
	}
}
?>
